<?php

function rpx_print_messages(){
  global $rpx_messages;
  $output = '';
  $id = 0;
  foreach ($rpx_messages as $key => $message_array){
    if ($message_array['message'] == ''){
      $message_array['message'] = 'Empty message.';
    }
    if ($message_array['class'] == ''){
      $message_array['class'] = 'message';
    }
    if ($message_array['class'] != 'html'){
      $message_array['class'] = htmlentities($message_array['class']);
      $message_array['message'] = nl2br(htmlentities($message_array['message']));
    }else{
      $message_array['class'] = 'message updated';
    }
    $id++;
    $output .= '<p id="rpx_message_'.$id.'" class="'.$message_array['class'].'">'.RPX_MESSAGE_PRE.$message_array['message'].'</p>';
  }
  if ($output != ''){
    echo '<div id="rpxmessage" class="message">'.$output.'</div>';
  }
  $rpx_messages = array();
}

function rpx_admin_menu_view(){
  global $rpx_comment_actions;
  global $rpx_http_vars;

  if ($rpx_http_vars['rpx_cleanup'] === 'true'){
    rpx_clean_locked();
  }

  $rpx_apikey = get_option(RPX_API_KEY_OPTION);
  if (strlen($rpx_apikey) == 40){
    if (get_option('users_can_register') == 1){
      rpx_message ('Janrain Engage is configured and active.', 'message');
    }else{
      rpx_message ('You must enable the Wordpress General Setting for Membership "Anyone can register".', 'error');
    }
  }else{
    rpx_message ('<strong>Enter valid API key.</strong><br />'
                .'Get your apiKey '
                 .'<a target="new" href="https://login.janrain.com/openid/v2/signin?token_url=https%3A%2F%2Frpxnow.com%2Ffinish">here</a>'
                 .' if you have an Engage account.<br />'
                .'View the account options '
                 .'<a target="new" href="http://www.janrain.com/products/engage/get-janrain-engage">here</a>'
                 .' to become a Janrain Engage customer.', 'html');
  }
  $rpx_test = rpx_test_api();
  if ($rpx_test['curl'] === false){
    rpx_message ('cURL version not supported. Please update PHP cURL.', 'error');
  }
  if ($rpx_test['post'] === false){
    rpx_message ('Unable to send POST to Engage server.', 'error');
  }
  if ($rpx_test['api'] === false){
    rpx_message ('Unable to retrive data from Engage API.', 'error');
  }
  ?>
<script type="text/javascript">
function rpxshowhide(box,val) {
  if(document.getElementById(box).checked==true) {
    document.getElementById(val).style.display="block";
  } else {
    document.getElementById(val).style.display="none";
  }
} 
</script>
<div class="wrap">
<h2>Janrain Engage</h2>
<?php rpx_print_messages(); ?>
<form method="post" action="options.php">
  <?php settings_fields( 'rpx_settings_group' ); ?>
  <table class="form-table">
    <tr>
      <td><label for="rpxapikey">Engage API Key: </label>
        <input id="rpxapikey" type="text" name="<?php echo RPX_API_KEY_OPTION; ?>" style="width:40em;" value="<?php echo get_option(RPX_API_KEY_OPTION); ?>" /></td>
    </tr><?php
  if (strlen(get_option(RPX_API_KEY_OPTION)) == 40){?>
    <tr>
      <td>
      <h3>Sign-In Settings</h3>
      Setup Sign-In widget <a target="_blank" href="<?php echo get_option(RPX_ADMIN_URL_OPTION); echo RPX_SIGNIN_SETUP_URL; ?>">here</a>.
      </td>
    </tr>
    <tr>
      <td><label for="rpxvemail">Allow sign in based on verifiedEmail match:</label>
      <input id="rpxvemail" type="checkbox" name="<?php echo RPX_VEMAIL_OPTION; ?>" value="true"<?php if (get_option(RPX_VEMAIL_OPTION) == 'true'){ echo ' checked="checked"'; } ?> /></td>
    </tr>
    <tr id="rpx_comment_option">
      <td><label for="rpxcomm">Login link for comments:</label>
       <select id="rpxcomm" name="<?php echo RPX_COMMENT_OPTION; ?>">
         <option value="none"<?php if (get_option(RPX_COMMENT_OPTION) == 'none'){ echo ' selected="selected"'; } ?>>None</option><?php
    foreach($rpx_comment_actions as $key => $val){?>
         <option value="<?php echo $val; ?>"<?php if (get_option(RPX_COMMENT_OPTION) == $val){ echo ' selected="selected"'; } ?>><?php echo $key; ?></option><?php
    }?>
       </select><br />*&nbsp;Wordpress&nbsp;3&nbsp;themes.<br />&sup1;&nbsp;For&nbsp;&quot;registered&nbsp;and&nbsp;logged&nbsp;in&nbsp;to&nbsp;comment&quot;
      </td>
    </tr>
    <tr>
      <td>
      <h4>Sign-In Regsistration</h4>
      Click <a href="?page=<?php echo RPX_MENU_SLUG; ?>&rpx_cleanup=true">here</a> to remove Engage incomplete (no email) accounts older than <?php echo RPX_CLEANUP_AGE; ?> minutes old.
      </td>
    </tr><?php
    if (get_option(RPX_SOCIAL_PUB) != ''){?>
    <tr>
      <td>
      <h3>Social Sharing Settings</h3>
      Setup Social Sharing widget <a target="_blank" href="<?php echo get_option(RPX_ADMIN_URL_OPTION); echo RPX_SOCIAL_SETUP_URL; ?>">here</a>.
      </td>
    </tr>
    <tr>
      <td><label for="rpxsocial">Enable social sharing:</label>
      <input onclick="rpxshowhide('rpxsocial','rpx_share_option')" id="rpxsocial" type="checkbox" name="<?php echo RPX_SOCIAL_OPTION; ?>" value="true"<?php if (get_option(RPX_SOCIAL_OPTION) == 'true'){ echo ' checked="checked"'; } ?> />
      </td>
    </tr>
    <tr id="rpx_share_option">
      <td><label for="rpxsloc">Share link on articles:</label>
       <select id="rpxsloc" name="<?php echo RPX_S_LOC_OPTION; ?>">
         <option value="none"<?php if (get_option(RPX_S_LOC_OPTION) == 'none'){ echo ' selected="selected"'; } ?>>None</option>
         <option value="top"<?php if (get_option(RPX_S_LOC_OPTION) == 'top'){ echo ' selected="selected"'; } ?>>at opening of article</option>
         <option value="bottom"<?php if (get_option(RPX_S_LOC_OPTION) == 'bottom'){ echo ' selected="selected"'; } ?>>at closing of article</option>
       </select>
      </td>
    </tr>
    <script type="text/javascript">rpxshowhide('rpxsocial','rpx_share_option');</script><?php
    }else{?>
    <tr>
      <td>Visit your <a href="<?php echo get_option(RPX_ADMIN_URL_OPTION); ?>">Janrain Engage dashboard</a> if you would like to enable social publishing.</td>
    </tr><?php
    }
  }?>
  </table>  
  <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
  </p>
</form>
</div><?php
}

function rpx_register_form() {
  global $rpx_http_vars;
  if ($rpx_http_vars['action'] != RPX_REGISTER_FORM_ACTION){
    return true;
  }
  if ($rpx_http_vars['rpx_session'] != ''){
    if ($rpx_http_vars['user_email'] != '') {
        rpx_message($rpx_http_vars['user_email']."\n".'The email address is already in use. '."\n".'Use another email address or login to that account.', 'rpxmessage');
    }else{
      $wptest = rpx_validate_user($rpx_http_vars['rpx_email']);
      if ($wptest === false){
        rpx_message('The email address entered is not valid. '."\n".'Enter a valid email address to register this account.', 'rpxmessage');
      }else{
        rpx_message('This '.$rpx_http_vars['rpx_provider'].' account did not provide an email address. '."\n".'Enter a valid email address to register this account.','rpxmessage');
      }
    }
  $rpxdir = get_option('siteurl') . '/wp-content/plugins/rpx/';
  $imgdir = $rpxdir.'images/';
?>
<div id="rpxregbox" class="rpxbox rpxregbox">
<div id="rpxregw1" class="rpxhoriz"></div>
<table id="rpxregw2" class="rpxvert"><tr id="rpxvrow" class="rpxvrow"><td id="rpxvcol" class="rpxvcol">
<span id="rpxregborder" class="rpxborder">
<span id="rpxregclose" class="rpxclose" onclick="hideRPX('rpxregbox')"><img src="<?php echo $imgdir; ?>close.png" alt="close" /></span>
<div id="rpxregister" class="rpxregister">
<?php rpx_print_messages(); ?>
<form id="rpxregform" class="rpxregform" action="" method="get">
<input type="hidden" name="action" value="<?php echo RPX_SESSION_ACTION; ?>" />
<input type="hidden" name="rpx_session" value="<?php echo urlencode($rpx_http_vars['rpx_session']); ?>" />
<input type="hidden" name="rpx_username" value="<?php echo urlencode($rpx_http_vars['rpx_username']); ?>" />
<input type="hidden" name="rpx_provider" value="<?php echo urlencode($rpx_http_vars['rpx_provider']); ?>" />
<input type="hidden" name="redirect_to" value="<?php echo urlencode($rpx_http_vars['redirect_to']); ?>" />
<input id="rpxemail" class="rpxemail" type="text" name="rpx_email" size="30" value="" />
<input id="rpxsubmit" class="rpxsubmit" type="submit" value="Submit" />
</form>
</div></span></td></tr></table></div>
<?php
  }
}

function rpx_wp_footer(){
  if (is_user_logged_in()){
    return true;
  }
  $realm = get_option(RPX_REALM_OPTION);
  $realm_scheme = get_option(RPX_REALM_SCHEME);
  global $rpx_http_vars;
  $rpx_token_url = RPX_TOKEN_URL.'&redirect_to='.urlencode($rpx_http_vars['redirect_to']);
  $iframe_src = $realm_scheme.'://' . $realm . '/openid/embed?token_url=' . urlencode($rpx_token_url);
  $rpxdir = get_option('siteurl') . '/wp-content/plugins/rpx/';
  $imgdir = $rpxdir.'images/';
  ?>
<div id="rpxlogin" class="rpxbox">
<div id="fiftyfifty" class="rpxhoriz"></div>
<table id="rpxvertical" class="rpxvert"><tr id="rpxvrow" class="rpxvrow"><td id="rpxvcol" class="rpxvcol">
<span id="rpx_border" class="rpxborder">
<span id="rpx_close" class="rpxclose" onclick="hideRPX('rpxlogin')"><img src="<?php echo $imgdir; ?>close.png" alt="close" /></span>
<iframe id="rpxiframe" class="rpxiframe" scrolling="no" src="<?php echo $iframe_src; ?>"></iframe>
</span></td></tr></table></div><?php
}

function rpx_head() {
  return true;
}


function rpx_login_form() {
  global $rpx_http_vars;
  if ($rpx_http_vars['action'] == 'register'){
    $logreg = 'register';
  }else{
    $logreg = 'log in';
  }
  rpx_print_messages();
  rpx_wp_footer();?>
<div class="label">Or <?php echo $logreg; ?> with</div><div class="rpx_button"><div id="rpx_icons" class="rpx_icons" onclick="showRPX('rpxlogin')">&nbsp;</div></div><?php
}

function rpx_login_head() {
  echo '<style type="text/css">';
  rpx_stylesheet(true);
  echo '</style>';
  echo '<script type="text/javascript">';
  rpx_javascript(true);
  echo '</script>';
}

function rpx_content_filter($content){
  if (get_option(RPX_SOCIAL_OPTION) != 'true' || get_option(RPX_SOCIAL_PUB) == '' || get_option(RPX_S_LOC_OPTION) == 'none'){
    return $content;
  }
  $posttitle   = rpx_js_escape(strip_tags(get_the_title()));
  $postlink    = rpx_js_escape(strip_tags(get_permalink()));
  $postsummary = rpx_js_escape(substr(strip_tags($content), 0, 46)).'...';
  $blogname    = rpx_js_escape(strip_tags(get_option('blogdescription')));

  $rpx_social  = '<div class="rpxsocial rpx_tooltip" onclick="rpxWPsocial(';
  $rpx_social .= "'Comment:','".$postsummary."','".$postlink."','".$posttitle."','Shared ".$posttitle." on ".$blogname."');";
  $rpx_social .= '">share<div class="rpx_share_tip">Share this on:<br />'.rpx_social_icons().'</div></div>';

  if (get_option(RPX_S_LOC_OPTION) == 'top'){
    return $rpx_social.$content;
  }else{
    return $content.$rpx_social;
  }
}

function rpx_share_comment(){?>
<p><input id="rpx_share_comment" name="rpx_share_comment" type="checkbox" /><label class="label" for="rpx_share_comment"> Share comment with:</label><?php
  echo rpx_social_icons();
?></p><?php
}

function rpx_widget($args) {
  extract($args);  
  echo $before_widget;
  echo $before_title.RPX_WIDGET_TITLE.$after_title;
  if (is_user_logged_in()){
    global $current_user;
    global $rpx_http_vars;
    get_currentuserinfo();?>
Welcome <?php echo $current_user->display_name; ?><br />
<a href="<?php echo wp_logout_url( $rpx_http_vars['redirect_to'] ); ?>" title="Logout">Log out</a><?php
  }else{
    echo rpx_small_buttons(RPX_LOGIN_PROMPT);
  }
  echo $after_widget;
}

function rpx_small_buttons($label = ''){
  global $rpx_button_count;
  global $rpx_providers_small;

  if ($label != ''){
    $label = '<div class="label">'.$label.'</div>';
  }
  $rpx_buttons = '';
  foreach ($rpx_providers_small as $key => $val){
    $rpx_buttons .= '<div class="rpx_icon_small rpx_'.$key.'_small" title="'.htmlentities($val).'"></div>';
  }
  $buttons = '<div class="rpx_button" id="rpx_button_'.++$rpx_button_count.'"><div class="rpx_small_icons" id="rpx_small_icons_'.++$rpx_button_count.'" onclick="showRPX(\'rpxlogin\')">'.$rpx_buttons.'</div></div>';
  return $label.$buttons;
}

function rpx_social_icons(){
  global $rpx_providers;
  $social_pub = get_option(RPX_SOCIAL_PUB);
  $social_providers = array_filter(explode(',',$social_pub));
  $rpx_social_icons = '';
  foreach ($social_providers as $key => $val){
    $rpx_social_icons .= '<div class="rpx_icon_small rpx_'.$val.'_small" title="'.htmlentities(array_search($val,$rpx_providers)).'"></div>';
  }
  $buttons = '<div class="rpx_social_icons">'.$rpx_social_icons.'</div>';
  return $label.$buttons;
}

function rpx_comment_login() {
  global $rpx_http_vars;
  rpx_set_redirect();
  if (is_user_logged_in()){
    global $current_user;
    get_currentuserinfo();
    ?>
<div id="rpxwidget"><p>Welcome <?php echo $current_user->display_name; ?><br />
<a href="<?php echo wp_logout_url( $rpx_http_vars['redirect_to'] ); ?>" title="Logout">Log out</a></p></div>
<?php
  }else{
    rpx_print_messages();
    $imgdir = get_option('siteurl') . '/wp-content/plugins/rpx/images/';
    ?>
<div id="rpxcomment"><?php echo rpx_small_buttons(RPX_COMMENT_PROMPT); ?></div><br />
<?php
  }
}


?>
