<?php
/*
Copyright 2010  Janrain  (email : info@janrain.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*
Plugin Name: Janrain Engage
Plugin URI: https://support.janrain.com/
Description: Plugin to add authentication via the Janrain Engage service.
Version: 1.0.1b
Author: forestb
Author URI: http://janrain.com/
*/

/*catch the current setting and disable display errors for security*/
if (ob_start()){
  $rpx_buffer = true;
}else{
  $rpx_buffer = false;
}
$rpx_original_edisplay = ini_get('display_errors');
ini_set('display_errors', 0);
$rpx_original_ereport = error_reporting(E_ERROR);

$rpx_path_root = dirname(__FILE__);
require_once(ABSPATH . WPINC . '/registration.php');
require_once($rpx_path_root . '/mvc/rpx_m.php');
require_once($rpx_path_root . '/rpx.conf.php');
require_once($rpx_path_root . '/mvc/rpx_c.php');
require_once($rpx_path_root . '/mvc/rpx_v.php');

function rpx_activate(){
  $rpx_api_key = get_option(RPX_API_KEY_OPTION);
  if ($rpx_api_key == ''){ $rpx_api_key = strip_tags($_POST[RPX_API_KEY_OPTION]); }
  if ($rpx_api_key != ''){
    $rpx_rp = rpx_get_rp($rpx_api_key);
    update_option(RPX_API_KEY_OPTION,   $rpx_rp['apiKey']);
    update_option(RPX_REALM_OPTION,     $rpx_rp['realm']);
    update_option(RPX_REALM_SCHEME,     $rpx_rp['realmScheme']);
    update_option(RPX_APP_ID_OPTION,    $rpx_rp['appId']);
    update_option(RPX_ADMIN_URL_OPTION, $rpx_rp['adminUrl']);
    update_option(RPX_SOCIAL_PUB,       $rpx_rp['socialPub']);    
    update_option(RPX_SOCIAL_OPTION,    RPX_SOCIAL_OPTION_DEFAULT);
    update_option(RPX_VEMAIL_OPTION,    RPX_VEMAIL_OPTION_DEFAULT);
  }
}

	 
function rpx_uninstall()
{
  delete_option(RPX_API_KEY_OPTION);
  delete_option(RPX_REALM_OPTION);
  delete_option(RPX_REALM_SCHEME);
  delete_option(RPX_APP_ID_OPTION);
  delete_option(RPX_ADMIN_URL_OPTION);
  delete_option(RPX_SOCIAL_PUB);
  delete_option(RPX_SOCIAL_OPTION);
  delete_option(RPX_VEMAIL_OPTION);
}

register_activation_hook(__FILE__, 'rpx_activate');
register_uninstall_hook(__FILE__, 'rpx_uninstall');


function rpx_init() {
  if (get_option(RPX_REALM_SCHEME) == 'http'){
      $rpx_scheme = 'http://static.';
    }else{
      $rpx_scheme = 'https://';
  }
  define('RPX_URL_SCHEME', $rpx_scheme);

  if (rpx_configured()) {
    global $current_user;
    get_currentuserinfo();
    $rpx_comment_option = rpx_get_comment_option();
    add_action(RPX_TOKEN_LOGIN_ACTION_NAME, 'rpx_process_token');
    add_action(RPX_SESSION_LOGIN_ACTION_NAME, 'rpx_process_session');
    add_action(RPX_REGISTER_FORM_ACTION_NAME, 'rpx_register_form');
    add_action('login_head',    'rpx_login_head');
    add_action('login_form',    'rpx_login_form');
    add_action('register_form', 'rpx_login_form');
    add_action('wp_head', 'rpx_head');
    if ($rpx_comment_option != ''){
      add_action($rpx_comment_option, 'rpx_comment_login');
    }
    //add_action('comment_form_logged_in_after', 'rpx_share_comment');
    wp_register_sidebar_widget('rpx_widget', 'Janrain Engage', 'rpx_widget');
    add_filter('the_content', 'rpx_content_filter');
    add_action('wp_footer', 'rpx_wp_footer');
  }else{
    rpx_activate();
  }
  add_action('wp_print_styles', 'rpx_stylesheet');
  add_action('wp_print_scripts', 'rpx_javascript');
  add_action('admin_menu', 'rpx_admin_menu');
  return;
}

add_action('init', 'rpx_init');

/*restore display errors to original setting*/
ini_set('display_errors', $rpx_original_edisplay);
error_reporting($rpx_original_ereport);
if ($rpx_buffer === true){
  if (error_get_last() == null){
    ob_end_flush();
  }else{
    ob_end_clean();
  }
}
?>
